using OrdinaryDiffEqLinear, Test, DiffEqDevTools
using OrdinaryDiffEqRosenbrock, OrdinaryDiffEqVerner, OrdinaryDiffEqTsit5
using LinearAlgebra, Random

# Linear exponential solvers
A = MatrixOperator([2.0 -1.0; -1.0 2.0])
u0 = ones(2)
prob = ODEProblem(A, u0, (0.0, 1.0))
solve(prob, LinearExponential(krylov = :off))

sol1 = solve(prob, LinearExponential(krylov = :off))(1.0)
sol2 = solve(prob, LinearExponential(krylov = :simple))(1.0)
sol3 = solve(prob, LinearExponential(krylov = :adaptive))(1.0)
sol4 = solve(prob, Rosenbrock23(), reltol = 1e-12, abstol = 1e-12)(1.0)
sol_analytic = exp(1.0 * Matrix(A)) * u0

@test isapprox(sol1, sol_analytic, rtol = 1e-10)
@test isapprox(sol2, sol_analytic, rtol = 1e-10)
@test isapprox(sol3, sol_analytic, rtol = 1e-10)
@test isapprox(sol4, sol_analytic, rtol = 1e-8)

# u' = A(t)u solvers
function update_func!(A, u, p, t)
    A[1, 1] = 0
    A[2, 1] = sin(u[1])
    A[1, 2] = -1
    A[2, 2] = 0
end
A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (10, 50.0))
sol1 = solve(prob, Vern9(), dt = 1 / 4)
sol2 = solve(prob, RKMK2(), dt = 1 / 4)
dts = 1 ./ 2 .^ (10:-1:5)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, RKMK2(), test_setup)
@test sim.𝒪est[:l2]≈2 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0, 30.0))
sol1 = solve(prob, Vern9(), dt = 1 / 4)
sol2 = solve(prob, RKMK4(), dt = 1 / 4)
dts = (0.38) .^ (6:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, RKMK4(), test_setup)
@test sim.𝒪est[:l2]≈4 atol=0.22

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0, 30.0))
sol1 = solve(prob, Vern9(), dt = 1 / 4)
sol2 = solve(prob, LieRK4(), dt = 1 / 4)
dts = 1 ./ 2 .^ (7:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, LieRK4(), test_setup)
@test sim.𝒪est[:l2]≈5 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0, 30.0))
sol1 = solve(prob, Vern9(), dt = 1 / 4)
sol2 = solve(prob, CG2(), dt = 1 / 4)
dts = 1 ./ 2 .^ (7:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, CG2(), test_setup)
@test sim.𝒪est[:l2]≈2 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0, 20.0))
sol1 = solve(prob, Vern6(), dt = 1 / 8)
sol2 = solve(prob, CG3(), dt = 1 / 8)
dts = 1 ./ 2 .^ (10:-1:3)
test_setup = Dict(:alg => Vern6(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, CG3(), test_setup)
@test sim.𝒪est[:l2]≈3 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0, 30.0))
sol1 = solve(prob, Vern9(), dt = 1 / 4)
sol2 = solve(prob, CG4a(), dt = 1 / 4)
dts = (0.38) .^ (6:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, CG4a(), test_setup)
@test sim.𝒪est[:l2]≈4 atol=0.28

function update_func!(A, u, p, t)
    A[1, 1] = 0
    A[2, 1] = 1
    A[1, 2] = -2 * (1 - cos(u[2]) - u[2] * sin(u[2]))
    A[2, 2] = 0
end
A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (30, 150.0))
dts = 1 ./ 2 .^ (7:-1:1)
test_setup = Dict(:alg => Tsit5(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusAdapt4(), test_setup)
@test sim.𝒪est[:l2]≈4 atol=0.2

function update_func!(A, u, p, t)
    A[1, 1] = cos(t)
    A[2, 1] = sin(t)
    A[1, 2] = -sin(t)
    A[2, 2] = cos(t)
end
A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0.0, 5.0))
dts = 1 ./ 2 .^ (10:-1:1)
sol = solve(prob, MagnusMidpoint(), dt = 1 / 4)

dts = 1 ./ 2 .^ (10:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusMidpoint(), test_setup)
@test sim.𝒪est[:l2]≈2 atol=0.2
sim = analyticless_test_convergence(dts, prob, MagnusMidpoint(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈2 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0.0, 5.0))
dts = 1 ./ 2 .^ (10:-1:1)
sol = solve(prob, MagnusLeapfrog(), dt = 1 / 4)

dts = 1 ./ 2 .^ (10:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusLeapfrog(), test_setup)
@test sim.𝒪est[:l2]≈2 atol=0.2
sim = analyticless_test_convergence(dts, prob, MagnusLeapfrog(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈2 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0.5, 5.0))
dts = 1 ./ 2 .^ (10:-1:1)
sol = solve(prob, LieEuler(), dt = 1 / 4)

dts = 1 ./ 2 .^ (10:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, LieEuler(), test_setup)
@test sim.𝒪est[:l2]≈1 atol=0.2
sim = analyticless_test_convergence(dts, prob, LieEuler(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈1 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (1.0, 6.0))
dts = 1 ./ 2 .^ (10:-1:1)
sol = solve(prob, MagnusGauss4(), dt = 1 / 4)

dts = 1 ./ 2 .^ (7:-1:1)
test_setup = Dict(:alg => Vern6(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusGauss4(), test_setup)
@test sim.𝒪est[:l2]≈4 atol=0.2
sim = analyticless_test_convergence(dts, prob, MagnusGauss4(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈4 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (1.0, 6.0))
dts = 1 ./ 2 .^ (4:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusNC6(), test_setup)
@test sim.𝒪est[:l2]≈6 atol=0.2
sim = analyticless_test_convergence(dts, prob, MagnusNC6(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈6 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (1.0, 6.0))
sol = solve(prob, MagnusGL6(), dt = 1 / 10)
dts = 1 ./ 2 .^ (4:-1:1)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusGL6(), test_setup)
@test sim.𝒪est[:l2]≈6 atol=0.3
sim = analyticless_test_convergence(dts, prob, MagnusGL6(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈6 atol=0.3

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0.0, 100.0))
dts = 1.775 .^ (5:-1:0)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusGL8(), test_setup)
@test sim.𝒪est[:l2]≈8 atol=0.2
sim = analyticless_test_convergence(dts, prob, MagnusGL8(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈8 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0.0, 100.0))
dts = 1.773 .^ (5:-1:0)
test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusNC8(), test_setup)
@test sim.𝒪est[:l2]≈8 atol=0.2
sim = analyticless_test_convergence(dts, prob, MagnusNC8(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈8 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (1.0, 6.0))
dts = 1 ./ 2 .^ (7:-1:1)
test_setup = Dict(:alg => Vern6(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, MagnusGL4(), test_setup)
@test sim.𝒪est[:l2]≈4 atol=0.2
sim = analyticless_test_convergence(dts, prob, MagnusGL4(krylov = true), test_setup)
@test sim.𝒪est[:l2]≈4 atol=0.2

A = MatrixOperator(ones(2, 2), update_func! = update_func!)
prob = ODEProblem(A, ones(2), (0, 20.0))
sol1 = solve(prob, Vern6(), dt = 1 / 8)
sol2 = solve(prob, CG3(), dt = 1 / 8)
dts = 1 ./ 2 .^ (10:-1:3)
test_setup = Dict(:alg => Vern6(), :reltol => 1e-14, :abstol => 1e-14)
sim = analyticless_test_convergence(dts, prob, CG3(), test_setup)
@test sim.𝒪est[:l2]≈3 atol=0.2

function B(y::AbstractMatrix)
    b = similar(y)
    N = size(b, 1)
    for l in 1:N
        for k in 1:l
            if k < l
                @inbounds b[k, l] = y[k, l - 1] - y[k + 1, l]
            else
                @inbounds b[k, l] = 0
            end
        end
    end
    for l in 1:N
        for k in (l + 1):N
            @inbounds b[k, l] = -b[l, k]
        end
    end

    return b
end

function update_func(A, u, p, t)
    B(u)
end

function update_func!(A, u, p, t)
    A .= B(u)
    return nothing
end

η = diagm([1.0, 2, 3, 4, 5])
A = MatrixOperator(Matrix{eltype(η)}(I(size(η, 1))), update_func = update_func,
    update_func! = update_func!)
dts = 1 ./ 2 .^ (10:-1:2)
tspan = (0.0, 20.0)

# IIP
f = SplitFunction(A, (du, u, p, t) -> du .= -u * B(u), _func_cache = similar(η))
prob = SplitODEProblem(f, η, tspan)
sol = solve(prob, CayleyEuler(), dt = 1 / 10)

@test sol.retcode == ReturnCode.Success
eig_err = [norm(eigvals(sol[i]) - eigvals(η)) for i in eachindex(sol)]
@test all(≈(e, 0, atol = 1e-13) for e in eig_err)

test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)

sim = analyticless_test_convergence(dts, prob, CayleyEuler(), test_setup)
@test sim.𝒪est[:l2]≈1 atol=0.2

# OOP
f = SplitFunction(A, (u, p, t) -> -u * B(u), _func_cache = similar(η))
prob = SplitODEProblem(f, η, tspan)
sol = solve(prob, CayleyEuler(), dt = 1 / 10)

@test sol.retcode == ReturnCode.Success
eig_err = [norm(eigvals(sol[i]) - eigvals(η)) for i in eachindex(sol)]
@test all(≈(e, 0, atol = 1e-13) for e in eig_err)

test_setup = Dict(:alg => Vern9(), :reltol => 1e-14, :abstol => 1e-14)

sim = analyticless_test_convergence(dts, prob, CayleyEuler(), test_setup)
@test sim.𝒪est[:l2]≈1 atol=0.2

# Linear Methods
REF1 = """
@article{celledoni2014introduction,
  title={An introduction to Lie group integrators--basics, new developments and applications},
  author={Celledoni, Elena and Marthinsen, H{\aa}kon and Owren, Brynjulf},
  journal={Journal of Computational Physics},
  volume={257},
  pages={1040--1061},
  year={2014},
  publisher={Elsevier}
}
"""
REF2 = """
@article{crouch1993numerical,
  title={Numerical integration of ordinary differential equations on manifolds},
  author={Crouch, Peter E and Grossman, R},
  journal={Journal of Nonlinear Science},
  volume={3},
  pages={1--33},
  year={1993},
  publisher={Springer}
}
"""
REF3 = """
@article{blanes2000improved,
  title={Improved high order integrators based on the Magnus expansion},
  author={Blanes, Sergio and Casas, Fernando and Ros, Javier},
  journal={BIT Numerical Mathematics},
  volume={40},
  number={3},
  pages={434--450},
  year={2000},
  publisher={Springer}
}
"""
REF4 = """
@article{blanes2009magnus,
  title={The Magnus expansion and some of its applications},
  author={Blanes, Sergio and Casas, Fernando and Oteo, Jose-Angel and Ros, Jos{\'e}},
  journal={Physics reports},
  volume={470},
  number={5-6},
  pages={151--238},
  year={2009},
  publisher={Elsevier}
}
"""
REF5 = """
@article{hairer2011solving,
  title={Solving differential equations on manifolds},
  author={Hairer, Ernst},
  journal={Lecture notes},
  year={2011}
}
"""
REF6 = """
@article{jackiewicz2000construction,
  title={Construction of Runge--Kutta methods of Crouch--Grossman type of high order},
  author={Jackiewicz, Zdzislaw and Marthinsen, Arne and Owren, Brynjulf},
  journal={Advances in Computational Mathematics},
  volume={13},
  pages={405--415},
  year={2000},
  publisher={Springer}
}
"""

for (Alg, Description, Ref) in [
        (
            :MagnusMidpoint, "Second order Magnus Midpoint method.",
            "https://joshuagoings.com/2017/06/15/magnus/",
        ),
        (
            :MagnusLeapfrog, "Second order Magnus Leapfrog method.",
            "https://joshuagoings.com/2017/06/15/magnus/",
        ),
        (:LieEuler, "description", REF1),
        (
            :MagnusGauss4,
            "Fourth order Magnus method approximated using a two stage Gauss quadrature.",
            REF5,
        ),
        (
            :MagnusNC6,
            "Sixth order Magnus method approximated using Newton-Cotes quadrature.", REF3,
        ),
        (
            :MagnusGL6,
            "Sixth order Magnus method approximated using Gauss-Legendre quadrature.", REF3,
        ),
        (
            :MagnusGL8,
            "Eighth order Magnus method approximated using Newton-Cotes quadrature.", REF3,
        ),
        (
            :MagnusNC8,
            "Eighth order Magnus method approximated using Gauss-Legendre quadrature.", REF3,
        ),
        (
            :MagnusGL4,
            "Fourth order Magnus method approximated using Gauss-Legendre quadrature.", REF4,
        ),
        (:RKMK2, "Second order Runge–Kutta–Munthe-Kaas method.", REF1),
        (:RKMK4, "Fourth order Runge–Kutta–Munthe-Kaas method.", REF1),
        (:LieRK4, "Fourth order Lie Runge-Kutta method.", REF1),
        (:CG2, "Second order Crouch–Grossman method.", REF1),
        (:CG3, "Third order Crouch-Grossman method.", REF2),
        (:CG4a, " Fourth order Crouch-Grossman method.", REF6),
    ]
    @eval begin
        @doc generic_solver_docstring(
            $Description,
            $(string(Alg)),
            "Semilinear ODE solver",
            $Ref,
            """
            - `krylov`: Determines whether Krylov approximation or operator caching is used, the latter only available for semilinear problems.
                `krylov=true` is much faster for larger systems and is thus recommended whenever there are >100 ODEs.
            - `m`: Controls the size of Krylov subspace.
            - `iop`: If not zero, determines the length of the incomplete orthogonalization procedure (IOP).
                    Note that if the linear operator/Jacobian is hermitian, then the Lanczos algorithm will always be used and the IOP setting is ignored.
            """,
            """
            krylov = false,
            m = 30,
            iop = 0,
            """
        )
        struct $Alg <: OrdinaryDiffEqLinearExponentialAlgorithm
            krylov::Bool
            m::Int
            iop::Int
        end
    end
    @eval $Alg(; krylov = false, m = 30, iop = 0) = $Alg(krylov, m, iop)
end

@doc generic_solver_docstring(
    "Fourth Order Adaptive Magnus method.",
    "MagnusAdapt4",
    "Semilinear ODE solver",
    "@article{li2008adaptive,
    title={Adaptive explicit Magnus numerical method for nonlinear dynamical systems},
    author={Li, Wen-cheng and Deng, Zi-chen},
    journal={Applied Mathematics and Mechanics},
    volume={29},
    number={9},
    pages={1111--1118},
    year={2008},
    publisher={Springer}}", "", ""
)
struct MagnusAdapt4 <: OrdinaryDiffEqAdaptiveAlgorithm end

@doc generic_solver_docstring(
    "First order method using Cayley transformations.",
    "CayleyEuler",
    "Semilinear ODE solver",
    "@article{iserles2000lie,
    title={Lie-group methods},
    author={Iserles, Arieh and Munthe-Kaas, Hans Z and Norsett, Syvert P and Zanna, Antonella},
    journal={Acta numerica},
    volume={9},
    pages={215--365},
    year={2000},
    publisher={Cambridge University Press}}", "", ""
)
struct CayleyEuler <: OrdinaryDiffEqAlgorithm end

@doc generic_solver_docstring(
    "Exact solution formula for linear, time-independent problems.",
    "LinearExponential",
    "Semilinear ODE solver",
    "@book{strogatz2018nonlinear,
    title={Nonlinear dynamics and chaos: with applications to physics, biology, chemistry, and engineering},
    author={Strogatz, Steven H},
    year={2018},
    publisher={CRC press}}",
    """
    - `krylov`:
        - `:off`: cache the operator beforehand. Requires Matrix(A) method defined for the operator A.
        - `:simple`: uses simple Krylov approximations with fixed subspace size m.
        - `:adaptive`: uses adaptive Krylov approximations with internal timestepping.
    - `m`: Controls the size of Krylov subspace if `krylov=:simple`, and the initial subspace size if `krylov=:adaptive`.
    - `iop`: If not zero, determines the length of the incomplete orthogonalization procedure
            Note that if the linear operator/Jacobian is hermitian,
            then the Lanczos algorithm will always be used and the IOP setting is ignored.
    """,
    """
    krylov = :off,
    m = 10,
    iop = 0,
    """
)
struct LinearExponential <:
    OrdinaryDiffEqExponentialAlgorithm{1, false, Val{:forward}, Val{true}, nothing}
    krylov::Symbol
    m::Int
    iop::Int
end
LinearExponential(; krylov = :off, m = 10, iop = 0) = LinearExponential(krylov, m, iop)

abstract type LinearMutableCache <: OrdinaryDiffEqMutableCache end
get_fsalfirstlast(cache::LinearMutableCache, u) = (cache.fsalfirst, cache.k)

@cache struct MagnusMidpointCache{uType, rateType, WType, expType} <:
              LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusMidpoint, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusMidpointCache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusMidpointConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusMidpoint, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusMidpointConstantCache()
end

@cache struct RKMK2Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::RKMK2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    RKMK2Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct RKMK2ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::RKMK2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    RKMK2ConstantCache()
end

@cache struct LieRK4Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::LieRK4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    LieRK4Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct LieRK4ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::LieRK4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    LieRK4ConstantCache()
end

@cache struct CG3Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::CG3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    CG3Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct CG3ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::CG3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    CG3ConstantCache()
end

@cache struct CG2Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::CG2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    CG2Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct CG2ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::CG2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    CG2ConstantCache()
end

@cache struct CG4aCache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::CG4a, u, rate_prototype, uEltypeNoUnits, uBottomEltypeNoUnits,
        tTypeNoUnits, uprev, uprev2, f, t, dt, reltol, p, calck, ::Val{true})
    W = false .* vec(rate_prototype) .* vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    CG4aCache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct CG4aConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::CG4a, u, rate_prototype, uEltypeNoUnits,
        tTypeNoUnits, uprev, uprev2, f, t, dt, reltol, p, calck, ::Val{false})
    CG4aConstantCache()
end

@cache struct RKMK4Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::RKMK4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    RKMK4Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct RKMK4ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::RKMK4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    RKMK4ConstantCache()
end

@cache struct MagnusAdapt4Cache{uType, rateType, WType, uNoUnitsType, expType} <:
              LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    utilde::uType
    atmp::uNoUnitsType
    exp_cache::expType
end

function alg_cache(alg::MagnusAdapt4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusAdapt4Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, utilde, atmp, exp_cache)
end

struct MagnusAdapt4ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusAdapt4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusAdapt4ConstantCache()
end

@cache struct MagnusNC8Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusNC8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusNC8Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusNC8ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusNC8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusNC8ConstantCache()
end

@cache struct MagnusGL4Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusGL4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusGL4Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusGL4ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusGL4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusGL4ConstantCache()
end

@cache struct MagnusGL8Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusGL8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusGL8Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusGL8ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusGL8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusGL8ConstantCache()
end

@cache struct MagnusNC6Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusNC6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusNC6Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusNC6ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusNC6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusNC6ConstantCache()
end

@cache struct MagnusGL6Cache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusGL6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusGL6Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusGL6ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusGL6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusGL6ConstantCache()
end
@cache struct MagnusGauss4Cache{uType, rateType, WType, expType} <:
              LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusGauss4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusGauss4Cache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusGauss4ConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusGauss4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusGauss4ConstantCache()
end

@cache struct LieEulerCache{uType, rateType, WType, expType} <: LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::LieEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    LieEulerCache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct LieEulerConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::LieEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    LieEulerConstantCache()
end

@cache struct CayleyEulerCache{uType, rateType} <: LinearMutableCache
    u::uType
    uprev::uType
    tmp::uType
    V::uType
    fsalfirst::rateType
    k::rateType
end

function alg_cache(alg::CayleyEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    CayleyEulerCache(u, uprev, zero(u), zero(u), fsalfirst, k)
end

struct CayleyEulerConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::CayleyEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    CayleyEulerConstantCache()
end

@cache struct MagnusLeapfrogCache{uType, rateType, WType, expType} <:
              LinearMutableCache
    u::uType
    uprev::uType
    uprev2::uType
    tmp::uType
    fsalfirst::rateType
    W::WType
    k::rateType
    exp_cache::expType
end

function alg_cache(alg::MagnusLeapfrog, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    W = false .* _vec(rate_prototype) .* _vec(rate_prototype)' # uEltype?
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    MagnusLeapfrogCache(u, uprev, uprev2, zero(u), fsalfirst, W, k, exp_cache)
end

struct MagnusLeapfrogConstantCache <: OrdinaryDiffEqConstantCache
end

function alg_cache(alg::MagnusLeapfrog, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    MagnusLeapfrogConstantCache()
end

struct LinearExponentialConstantCache <: OrdinaryDiffEqConstantCache end

function alg_cache(alg::LinearExponential, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    LinearExponentialConstantCache()
end

@cache struct LinearExponentialCache{uType, rateType, KsType, expType} <:
              LinearMutableCache
    u::uType
    uprev::uType
    tmp::uType
    rtmp::rateType
    KsCache::KsType # different depending on alg.krylov
    exp_cache::expType
end

get_fsalfirstlast(cache::LinearExponentialCache, u) = (zero(u), zero(u))

function _phiv_timestep_caches(u_prototype, maxiter::Int, p::Int)
    n = length(u_prototype)
    T = eltype(u_prototype)
    u = zero(u_prototype)                         # stores the current state
    W = similar(u_prototype, n, p + 1)              # stores the w vectors                
    P = similar(u_prototype, n, p + 2)              # stores output from phiv!  
    Ks = KrylovSubspace{T, T, typeof(similar(u_prototype, size(u_prototype, 1), 2))}(
        n, maxiter) # stores output from arnoldi!
    phiv_cache = PhivCache(u_prototype, maxiter, p + 1) # cache used by phiv! (need +1 for error estimation)
    return u, W, P, Ks, phiv_cache
end

function alg_cache(alg::LinearExponential, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    rtmp = zero(rate_prototype)
    n = length(u)
    T = eltype(u)
    m = min(alg.m, n)

    if alg.krylov == :off
        KsCache = nothing
    elseif alg.krylov == :simple
        Ks = KrylovSubspace{T, T, typeof(similar(u, size(u, 1), 2))}(n, m)
        expv_cache = ExpvCache{T}(m)
        KsCache = (Ks, expv_cache)
    elseif alg.krylov == :adaptive
        KsCache = _phiv_timestep_caches(u, m, 0)
    else
        throw(ArgumentError("Unknown krylov setting $(alg.krylov). Can be :off, :simple or :adaptive."))
    end
    exp_cache = ExponentialUtilities.alloc_mem(f, ExpMethodGeneric())
    LinearExponentialCache(u, uprev, tmp, rtmp, KsCache, exp_cache)
end

function initialize!(integrator, cache::MagnusMidpointCache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusMidpointCache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, u, p, t + dt / 2)

    if alg.krylov
        u .= expv(dt, L, u; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        A = convert(AbstractMatrix, L)
        u .= exponential!(dt * A, exp_method, exp_cache) * u
    end

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end
function initialize!(integrator, cache::LieRK4Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::LieRK4Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f

    Y1 = uprev
    update_coefficients!(L, Y1, p, t)
    k1 = dt * convert(AbstractMatrix, L)

    Y2 = exponential!(k1 / 2, exp_method, exp_cache) * uprev
    update_coefficients!(L, Y2, p, t)
    k2 = dt * convert(AbstractMatrix, L)

    Y3 = exponential!(k2 / 2, exp_method, exp_cache) * uprev
    update_coefficients!(L, Y3, p, t)
    k3 = dt * convert(AbstractMatrix, L)

    Y4 = exponential!(k3 - k1 / 2, exp_method, exp_cache) * Y2
    update_coefficients!(L, Y4, p, t)
    k4 = dt * convert(AbstractMatrix, L)

    y1_2 = exponential!((3 * k1 + 2 * k2 + 2 * k3 - k4) / 12, exp_method, exp_cache) * uprev

    if alg.krylov
        u .= expv((1 / 12), (-k1 + 2 * k2 + 2 * k3 + 3 * k4), y1_2;
            m = min(alg.m, size(L, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop)
    else
        u .= exponential!((1 / 12) * (-k1 + 2 * k2 + 2 * k3 + 3 * k4),
            exp_method,
            exp_cache) *
             y1_2
    end

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::RKMK4Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::RKMK4Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t)
    k1 = dt * convert(AbstractMatrix, L)
    update_coefficients!(L, exponential!(k1 / 2, exp_method, exp_cache) * uprev, p, t)
    k2 = dt * convert(AbstractMatrix, L)
    update_coefficients!(L,
        exponential!(k1 / 2 - (k1 * k2 - k2 * k1) / 8, exp_method, exp_cache) * uprev,
        p,
        t)
    k3 = dt * convert(AbstractMatrix, L)
    update_coefficients!(L, exponential!(k3, exp_method, exp_cache) * uprev, p, t)
    k4 = dt * convert(AbstractMatrix, L)
    if alg.krylov
        u .= expv(1 / 6, (k1 + 2 * k2 + 2 * k3 + k4 - (k1 * k4 - k4 * k1) / 2), uprev;
            m = min(alg.m, size(L, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop)
    else
        u .= exponential!((1 / 6) * (k1 + 2 * k2 + 2 * k3 + k4 - (k1 * k4 - k4 * k1) / 2),
            exp_method,
            exp_cache) * uprev
    end

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::RKMK2Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::RKMK2Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t)
    k1 = dt * convert(AbstractMatrix, L)
    update_coefficients!(L, exponential!(k1, exp_method, exp_cache) * uprev, p, t)
    k2 = dt * convert(AbstractMatrix, L)
    if alg.krylov
        u .= expv(1 / 2, (k1 + k2), uprev; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u .= exponential!((1 / 2) * (k1 + k2), exp_method, exp_cache) * uprev
    end

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::CG3Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::CG3Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t)
    A = deepcopy(convert(AbstractMatrix, L))
    v2 = exponential!((3 / 4) * dt * A, exp_method, exp_cache) * uprev
    update_coefficients!(L, v2, p, t + (3 * dt / 4))
    B = deepcopy(convert(AbstractMatrix, L))
    v3 = exponential!((119 / 216) * dt * B, exp_method, exp_cache) *
         exponential!((17 / 108) * dt * A, exp_method, exp_cache) * uprev
    update_coefficients!(L, v3, p, t + (17 * dt / 24))
    C = convert(AbstractMatrix, L)
    u .= (exponential!(dt * (24 / 17) * C, exp_method, exp_cache) *
          exponential!(dt * (-2 / 3) * B, exp_method, exp_cache) *
          exponential!(dt * (13 / 51) * A, exp_method, exp_cache)) *
         uprev

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::CG2Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::CG2Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t)
    k1 = dt * convert(AbstractMatrix, L)
    update_coefficients!(L, exponential!(k1, exp_method, exp_cache) * uprev, p, t)
    k2 = dt * convert(AbstractMatrix, L)
    u .= (exponential!((1 / 2) * (k1), exp_method, exp_cache) *
          (exponential!((1 / 2) * k2, exp_method, exp_cache))) * uprev

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::CG4aCache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::CG4aCache, repeat_step = false)
    (; t, dt, uprev, u, p, alg) = integrator
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t)
    A = deepcopy(convert(AbstractMatrix, L))
    v2 = exponential!((0.8177227988124852) * dt * A, exp_method, exp_cache) * uprev
    update_coefficients!(L, v2, p, t + (0.8177227988124852 * dt))
    B = deepcopy(convert(AbstractMatrix, L))
    v3 = exponential!((0.3199876375476427) * dt * B, exp_method, exp_cache) *
         exponential!((0.0659864263556022) * dt * A, exp_method, exp_cache) * uprev
    update_coefficients!(L, v3, p, t + (0.3859740639032449 * dt))
    C = deepcopy(convert(AbstractMatrix, L))
    v4 = exponential!((0.9214417194464946) * dt * C, exp_method, exp_cache) *
         exponential!((0.4997857776773573) * dt * B, exp_method, exp_cache) *
         exponential!((-1.0969984448371582) * dt * A, exp_method, exp_cache) * uprev
    update_coefficients!(L, v4, p, t + (0.3242290522866937 * dt))
    D = deepcopy(convert(AbstractMatrix, L))
    v5 = exponential!((0.3552358559023322) * dt * D, exp_method, exp_cache) *
         exponential!((0.2390958372307326) * dt * C, exp_method, exp_cache) *
         exponential!((1.3918565724203246) * dt * B, exp_method, exp_cache) *
         exponential!((-1.1092979392113465) * dt * A, exp_method, exp_cache) * uprev
    update_coefficients!(L, v5, p, t + (0.8768903263420429 * dt))
    E = convert(AbstractMatrix, L)
    u .= (exponential!(dt * (0.3322195591068374) * E, exp_method, exp_cache) *
          exponential!(dt * (-0.1907142565505889) * D, exp_method, exp_cache) *
          exponential!(dt * (0.7397813985370780) * C, exp_method, exp_cache) *
          exponential!(dt * (-0.0183698531564020) * B, exp_method, exp_cache) *
          exponential!(dt * (0.1370831520630755) * A, exp_method, exp_cache)) * uprev

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::MagnusAdapt4Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusAdapt4Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    (; W, k, tmp, utilde, atmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t)
    A0 = deepcopy(convert(AbstractMatrix, L))
    k1 = dt * A0
    Q1 = k1

    y2 = (1 / 2) * Q1
    update_coefficients!(L, exponential!(y2, exp_method, exp_cache) * uprev, p, t + dt / 2)
    A1 = deepcopy(convert(AbstractMatrix, L))
    k2 = dt * A1
    Q2 = k2 - k1

    y3 = (1 / 2) * Q1 + (1 / 4) * Q2
    update_coefficients!(L, exponential!(y3, exp_method, exp_cache) * uprev, p, t + dt / 2)
    A2 = deepcopy(convert(AbstractMatrix, L))
    k3 = dt * A2
    Q3 = k3 - k2

    y4 = Q1 + Q2
    update_coefficients!(L, exponential!(y4, exp_method, exp_cache) * uprev, p, t + dt)
    A3 = deepcopy(convert(AbstractMatrix, L))
    k4 = dt * A3
    Q4 = k4 - 2 * k2 + k1

    y5 = (1 / 2) * Q1 + (1 / 4) * Q2 + (1 / 3) * Q3 - (1 / 24) * Q4 -
         (1 / 48) * (Q1 * Q2 - Q2 * Q1)
    update_coefficients!(L, exponential!(y5, exp_method, exp_cache) * uprev, p, t + dt / 2)
    A4 = deepcopy(convert(AbstractMatrix, L))
    k5 = dt * A4
    Q5 = k5 - k2

    y6 = Q1 + Q2 + (2 / 3) * Q3 + (1 / 6) * Q4 - (1 / 6) * (Q1 * Q2 - Q2 * Q1)
    update_coefficients!(L, exponential!(y6, exp_method, exp_cache) * uprev, p, t + dt)
    A5 = convert(AbstractMatrix, L)
    k6 = dt * A5
    Q6 = k6 - 2 * k2 + k1

    v4 = Q1 + Q2 + (2 / 3) * Q5 + (1 / 6) * Q6 -
         (1 / 6) * (Q1 * (Q2 - Q3 + Q5 + (1 / 2) * Q6) - (Q2 - Q3 + Q5 + (1 / 2) * Q6) * Q1)

    u .= exponential!(v4, exp_method, exp_cache) * uprev

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    if integrator.opts.adaptive
        utilde = u - exponential!(y6, exp_method, exp_cache) * uprev
        calculate_residuals!(atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

function initialize!(integrator, cache::MagnusNC8Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusNC8Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f

    update_coefficients!(L, u, p, t)
    A0 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, u, p, t + dt / 6)
    A1 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, u, p, t + 2 * dt / 6)
    A2 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, u, p, t + 3 * dt / 6)
    A3 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, u, p, t + 4 * dt / 6)
    A4 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, u, p, t + 5 * dt / 6)
    A5 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, u, p, t + dt)
    A6 = convert(AbstractMatrix, L)

    S1 = A0 + A6
    S2 = A1 + A5
    S3 = A2 + A4
    S4 = A3
    R1 = A6 - A0
    R2 = A5 - A1
    R3 = A4 - A2

    B0 = (1 / 840) * (41 * S1 + 216 * S2 + 27 * S3 + 272 * S4)
    B2 = (1 / 840) * (41 * S1 / 4 + 216 * S2 / 9 + 27 * S3 / 36)
    B1 = (1 / 840) * (41 * R1 / 2 + 216 * R2 / 3 + 27 * R3 / 6)
    B3 = (1 / 840) * (41 * R1 / 8 + 216 * R2 / 27 + 27 * R3 / 216)

    Q1 = (-38 * B0 / 5 + 24 * B2) * B3 - B3 * (-38 * B0 / 5 + 24 * B2)
    Q2 = (63 * B0 / 5 - 84 * B2) * (-5 * B1 / 28 + B3) -
         (-5 * B1 / 28 + B3) * (63 * B0 / 5 - 84 * B2)
    Q3 = (19 * B0 / 28 - 15 * B2 / 7) * (B0 * (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) -
          (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) * B0) -
         (B0 * (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) -
          (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) * B0) * (19 * B0 / 28 - 15 * B2 / 7)
    Q4 = B3 * (20 * Q1 / 7 + 10 * Q2) - (20 * Q1 / 7 + 10 * Q2) * B3
    Q5 = (-6025 * B0 / 4116 + 2875 * B2 / 343) * (B2 * Q1 - Q1 * B2) -
         (B2 * Q1 - Q1 * B2) * (-6025 * B0 / 4116 + 2875 * B2 / 343)
    Q6 = B3 * (20 * (Q3 + Q4) / 7 + 820 * dt * Q5 / 189) -
         (20 * (Q3 + Q4) / 7 + 820 * dt * Q5 / 189) * B3
    Q7 = (-1 / 42) * (B0 * (B0 * (Q3 - Q4 / 3 + dt * Q5) - (Q3 - Q4 / 3 + dt * Q5) * B0) -
          (B0 * (Q3 - Q4 / 3 + dt * Q5) - (Q3 - Q4 / 3 + dt * Q5) * B0) * B0)

    Ω1 = dt * B0
    Ω2 = (dt^2) * (Q1 + Q2)
    Ω3_4_5_6 = (dt^3) * (Q3 + Q4) + (dt^4) * (Q5 + Q6) + (dt^5) * Q7
    if alg.krylov
        u .= expv(1.0, Ω1 + Ω2 + Ω3_4_5_6, uprev; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u .= exponential!(Ω1 + Ω2 + Ω3_4_5_6, exp_method, exp_cache) * uprev
    end
    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::MagnusGL4Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusGL4Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t + dt * (1 / 2 - sqrt(3) / 6))
    A1 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt * (1 / 2 + sqrt(3) / 6))
    A2 = convert(AbstractMatrix, L)

    Ω = (dt / 2) * (A1 + A2) - (dt^2) * (sqrt(3) / 12) * (A1 * A2 - A2 * A1)

    if alg.krylov
        u .= expv(1.0, Ω, uprev; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u .= exponential!(Ω, exp_method, exp_cache) * uprev
    end
    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::MagnusGL8Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusGL8Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    v1 = (1 / 2) * sqrt((3 + 2 * sqrt(6 / 5)) / 7)
    v2 = (1 / 2) * sqrt((3 - 2 * sqrt(6 / 5)) / 7)
    update_coefficients!(L, uprev, p, t - dt * v1 + dt / 2)
    A1 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt * v1 + dt / 2)
    A4 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t - dt * v2 + dt / 2)
    A2 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt * v2 + dt / 2)
    A3 = convert(AbstractMatrix, L)
    w1 = (1 / 2) - (1 / 6) * sqrt(5 / 6)
    w2 = (1 / 2) + (1 / 6) * sqrt(5 / 6)
    S1 = A1 + A4
    S2 = A2 + A3
    R1 = A4 - A1
    R2 = A3 - A2

    B0 = (1 / 2) * (w1 * S1 + w2 * S2)
    B2 = (1 / 2) * ((v1^2) * w1 * S1 + (v2^2) * w2 * S2)
    B1 = (1 / 2) * (v1 * w1 * R1 + v2 * w2 * R2)
    B3 = (1 / 2) * ((v1^3) * w1 * R1 + (v2^3) * w2 * R2)
    Q1 = (-38 * B0 / 5 + 24 * B2) * B3 - B3 * (-38 * B0 / 5 + 24 * B2)
    Q2 = (63 * B0 / 5 - 84 * B2) * (-5 * B1 / 28 + B3) -
         (-5 * B1 / 28 + B3) * (63 * B0 / 5 - 84 * B2)
    Q3 = (19 * B0 / 28 - 15 * B2 / 7) * (B0 * (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) -
          (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) * B0) -
         (B0 * (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) -
          (B2 + dt * (61 * Q1 / 588 - Q2 / 12)) * B0) * (19 * B0 / 28 - 15 * B2 / 7)
    Q4 = B3 * (20 * Q1 / 7 + 10 * Q2) - (20 * Q1 / 7 + 10 * Q2) * B3
    Q5 = (-6025 * B0 / 4116 + 2875 * B2 / 343) * (B2 * Q1 - Q1 * B2) -
         (B2 * Q1 - Q1 * B2) * (-6025 * B0 / 4116 + 2875 * B2 / 343)
    Q6 = B3 * (20 * (Q3 + Q4) / 7 + 820 * dt * Q5 / 189) -
         (20 * (Q3 + Q4) / 7 + 820 * dt * Q5 / 189) * B3
    Q7 = (-1 / 42) * (B0 * (B0 * (Q3 - Q4 / 3 + dt * Q5) - (Q3 - Q4 / 3 + dt * Q5) * B0) -
          (B0 * (Q3 - Q4 / 3 + dt * Q5) - (Q3 - Q4 / 3 + dt * Q5) * B0) * B0)

    Ω1 = dt * B0
    Ω2 = (dt^2) * (Q1 + Q2)
    Ω3_4_5_6 = (dt^3) * (Q3 + Q4) + (dt^4) * (Q5 + Q6) + (dt^5) * Q7
    if alg.krylov
        u .= expv(1.0, Ω1 + Ω2 + Ω3_4_5_6, uprev; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u .= exponential!(Ω1 + Ω2 + Ω3_4_5_6, exp_method, exp_cache) * uprev
    end
    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::MagnusNC6Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusNC6Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t)
    A0 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt / 4)
    A1 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt / 2)
    A2 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + 3 * dt / 4)
    A3 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt)
    A4 = convert(AbstractMatrix, L)
    B0 = (1 / 90) * (7 * (A0 + A4) + 32 * (A1 + A3) + 12 * (A2))
    B1 = (1 / 90) * ((7 / 2) * (A4 - A0) + 8 * (A3 - A1))
    B2 = (1 / 90) * ((7 / 4) * (A0 + A4) + 2 * (A1 + A3))
    Ω1 = dt * B0
    Ω2 = (dt * dt) * (B1 * (3 * B0 / 2 - 6 * B2) - (3 * B0 / 2 - 6 * B2) * B1)
    Ω3_4 = (dt * dt) *
           (B0 * (B0 * (dt * B2 / 2 - Ω2 / 60) - (dt * B2 / 2 - Ω2 / 60) * B0) -
            (B0 * (dt * B2 / 2 - Ω2 / 60) - (dt * B2 / 2 - Ω2 / 60) * B0) * B0) +
           (3 * dt / 5) * (B1 * Ω2 - Ω2 * B1)
    if alg.krylov
        u .= expv(1.0, Ω1 + Ω2 + Ω3_4, uprev; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u .= exponential!(Ω1 + Ω2 + Ω3_4, exp_method, exp_cache) * uprev
    end
    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::MagnusGL6Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusGL6Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t - dt * (sqrt(3 / 20)) + dt / 2)
    A1 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt / 2)
    A2 = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt * (sqrt(3 / 20)) + dt / 2)
    A3 = convert(AbstractMatrix, L)
    B0 = (1 / 18) * (5 * (A1 + A3) + 8 * A2)
    B1 = (sqrt(15) / 36) * (A3 - A1)
    B2 = (1 / 24) * (A1 + A3)
    Ω1 = dt * B0
    Ω2 = (dt * dt) * (B1 * (3 * B0 / 2 - 6 * B2) - (3 * B0 / 2 - 6 * B2) * B1)
    Ω3_4 = (dt * dt) *
           (B0 * (B0 * (dt * B2 / 2 - Ω2 / 60) - (dt * B2 / 2 - Ω2 / 60) * B0) -
            (B0 * (dt * B2 / 2 - Ω2 / 60) - (dt * B2 / 2 - Ω2 / 60) * B0) * B0) +
           (3 * dt / 5) * (B1 * Ω2 - Ω2 * B1)
    if alg.krylov
        u .= expv(1.0, Ω1 + Ω2 + Ω3_4, uprev; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u .= exponential!(Ω1 + Ω2 + Ω3_4, exp_method, exp_cache) * uprev
    end
    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::MagnusGauss4Cache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusGauss4Cache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, uprev, p, t + dt * (1 / 2 + sqrt(3) / 6))
    A = deepcopy(convert(AbstractMatrix, L))
    update_coefficients!(L, uprev, p, t + dt * (1 / 2 - sqrt(3) / 6))
    B = convert(AbstractMatrix, L)
    if alg.krylov
        u .= expv(dt, (A + B) ./ 2 + (dt * sqrt(3)) .* (B * A - A * B) ./ 12, u;
            m = min(alg.m, size(L, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop)
    else
        u .= exponential!(
            (dt / 2) .* (A + B) +
            ((dt^2) * (sqrt(3) / 12)) .* (B * A - A * B),
            exp_method,
            exp_cache) * uprev
    end
    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::LieEulerCache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::LieEulerCache, repeat_step = false)
    (; t, dt, uprev, u, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()

    L = integrator.f.f
    update_coefficients!(L, u, p, t)

    if alg.krylov
        u .= expv(dt, L, u; m = min(alg.m, size(L, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u .= exponential!(dt * convert(AbstractMatrix, L), exp_method, exp_cache) * u
    end

    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::MagnusLeapfrogCache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::MagnusLeapfrogCache, repeat_step = false,
        alg_extrapolates = true, iter = 1)
    (; t, dt, uprev, uprev2, u, p, iter) = integrator
    alg = unwrap_alg(integrator, nothing)
    (; W, k, tmp, exp_cache) = cache
    mass_matrix = integrator.f.mass_matrix
    exp_method = ExpMethodGeneric()
    # println("iter   : $iter")
    if iter == 1
        L = integrator.f.f
        update_coefficients!(L, u, p, t + dt / 2)
        if alg.krylov
            u .= expv(dt, L, u; m = min(alg.m, size(L, 1)),
                opnorm = integrator.opts.internalopnorm, iop = alg.iop)
        else
            A = convert(AbstractMatrix, L)
            u .= exponential!(dt * A, exp_method, exp_cache) * u
        end

        integrator.f(integrator.fsallast, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        iter += 1
    else
        L = integrator.f.f
        update_coefficients!(L, u, p, t)
        if alg.krylov
            u .= expv(2 * dt, L, uprev2; m = min(alg.m, size(L, 1)),
                opnorm = integrator.opts.internalopnorm, iop = alg.iop)
        else
            A = convert(AbstractMatrix, L)
            u .= exponential!(2 * dt * A, exp_method, exp_cache) * uprev2
        end
        uprev = u
        integrator.f(integrator.fsallast, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
end

function initialize!(integrator, cache::LinearExponentialConstantCache)
    # Pre-start fsal
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.fsallast = zero(integrator.fsalfirst)

    # Initialize interpolation derivatives
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

function perform_step!(integrator, cache::LinearExponentialConstantCache,
        repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    alg = unwrap_alg(integrator, nothing)
    A = convert(AbstractMatrix, f.f) # assume f to be an ODEFunction wrapped around a linear operator

    if alg.krylov == :off
        u = exponential!(dt * A, ExpMethodGeneric()) * integrator.u
    elseif alg.krylov == :simple
        u = expv(dt, A, integrator.u; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
    else
        u = expv_timestep(dt, A, integrator.u; m = min(alg.m, size(A, 1)), iop = alg.iop,
            opnorm = integrator.opts.internalopnorm,
            tol = integrator.opts.reltol)
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

function initialize!(integrator, cache::LinearExponentialCache)
    # Pre-start fsal
    integrator.fsalfirst = zero(cache.rtmp)
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.fsallast = zero(integrator.fsalfirst)

    # Initialize interpolation derivatives
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

function perform_step!(integrator, cache::LinearExponentialCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, KsCache, exp_cache) = cache
    alg = unwrap_alg(integrator, nothing)
    exp_method = ExpMethodGeneric()
    A = convert(AbstractMatrix, f.f) # assume f to be an ODEFunction wrapped around a linear operator

    if alg.krylov == :off
        E = exponential!(dt * A, exp_method, exp_cache)
        mul!(tmp, E, u)
    elseif alg.krylov == :simple
        Ks, expv_cache = KsCache
        arnoldi!(Ks, A, u; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop)
        expv!(tmp, dt, Ks; cache = expv_cache)
    else
        expv_timestep!(tmp, dt, A, u; adaptive = true, caches = KsCache,
            m = min(alg.m, size(A, 1)), iop = alg.iop,
            opnorm = integrator.opts.internalopnorm,
            tol = integrator.opts.reltol)
    end

    # Update integrator state
    u .= tmp
    f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

cay!(tmp, A) = mul!(tmp, inv(I - 1 / 2 * A), (I + 1 / 2 * A))
cay!(tmp, A::AbstractSciMLOperator) = @error "cannot multiply two SciMLOperators with mul!"
cay(A) = inv(I - 1 / 2 * A) * (I + 1 / 2 * A)

function initialize!(integrator, cache::CayleyEulerConstantCache)
    # Pre-start fsal
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.fsallast = zero(integrator.fsalfirst)

    # Initialize interpolation derivatives
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

function perform_step!(integrator, cache::CayleyEulerConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator

    if f isa SplitFunction
        A = f.f1.f
    else  # f isa ODEFunction
        A = f.f
    end

    L = update_coefficients(A, uprev, p, t)
    L = convert(AbstractMatrix, L)

    V = cay(L * dt)
    u = (V * uprev) * transpose(V)

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

function initialize!(integrator, cache::CayleyEulerCache)
    integrator.kshortsize = 2

    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # For the interpolation, needs k at the updated point
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function perform_step!(integrator, cache::CayleyEulerCache, repeat_step = false)
    (; t, dt, uprev, u, p, f) = integrator
    (; k, V, tmp) = cache
    mass_matrix = integrator.f.mass_matrix

    if f isa SplitFunction
        L = f.f1.f
    else  # f isa ODEFunction
        L = f.f
    end

    update_coefficients!(L, uprev, p, t)
    L = convert(AbstractMatrix, L)

    cay!(V, L * dt)
    mul!(tmp, uprev, transpose(V))
    mul!(u, V, tmp)

    # Update integrator state
    integrator.f(integrator.fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

using Pkg
Pkg.add("JET")

import OrdinaryDiffEqLinear
using JET

@testset "JET Tests" begin
    test_package(
        OrdinaryDiffEqLinear, target_modules = (OrdinaryDiffEqLinear,), mode = :typo
    )
end

module OrdinaryDiffEqLinear

import OrdinaryDiffEqCore: alg_order, alg_extrapolates, dt_required,
    OrdinaryDiffEqLinearExponentialAlgorithm,
    OrdinaryDiffEqAdaptiveAlgorithm, OrdinaryDiffEqAlgorithm,
    OrdinaryDiffEqExponentialAlgorithm,
    OrdinaryDiffEqMutableCache, @cache, alg_cache,
    OrdinaryDiffEqConstantCache,
    initialize!, perform_step!, unwrap_alg,
    calculate_residuals!, get_fsalfirstlast,
    _vec, isdtchangeable, full_cache,
    generic_solver_docstring
using LinearAlgebra: mul!, I
using SciMLOperators: AbstractSciMLOperator
using ExponentialUtilities
using RecursiveArrayTools
import OrdinaryDiffEqCore
import DiffEqBase

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("linear_caches.jl")
include("integrator_interface.jl")
include("linear_perform_step.jl")

export MagnusMidpoint, LinearExponential, MagnusLeapfrog, LieEuler, CayleyEuler,
    MagnusGauss4, MagnusNC6, MagnusGL6, MagnusGL8, MagnusNC8, MagnusGL4,
    MagnusAdapt4, RKMK2, RKMK4, LieRK4, CG2, CG3, CG4a

end

alg_order(alg::MagnusMidpoint) = 2
alg_order(alg::RKMK2) = 2
alg_order(alg::RKMK4) = 4
alg_order(alg::LieRK4) = 4
alg_order(alg::CG3) = 3
alg_order(alg::CG2) = 2
alg_order(alg::CG4a) = 4
alg_order(alg::MagnusAdapt4) = 4
alg_order(alg::MagnusGauss4) = 4
alg_order(alg::MagnusNC6) = 6
alg_order(alg::MagnusGL6) = 6
alg_order(alg::MagnusGL8) = 8
alg_order(alg::MagnusNC8) = 8
alg_order(alg::MagnusGL4) = 4
alg_order(alg::LinearExponential) = 1
alg_order(alg::MagnusLeapfrog) = 2
alg_order(alg::LieEuler) = 1
alg_order(alg::CayleyEuler) = 2

alg_extrapolates(alg::MagnusLeapfrog) = true

dt_required(alg::LinearExponential) = false

function DiffEqBase.prepare_alg(
        alg::LinearExponential,
        u0::AbstractArray,
        p, prob
    )
    return alg
end

function isdtchangeable(alg::Union{LieEuler, MagnusGauss4, CayleyEuler})
    return false
end # due to caching
